<?php

include ("vglib.php");

CheckCookie();

include ("lib-search.php");

function PrintCommandsArray($inp)
{	$len=count($inp);
	$x=0;
	echo "<span class='c'>";
	while ($x<$len)
	{	$res .= $inp[$x];
		$res .= ", ";
		$x++;
	}
	$res=substr($res, 0, -2); //removes trailing comma

	echo "$res</span>";

}

echo "<html><head><title>Search Commands</title>
<link rel=stylesheet href='css/a.css' type='text/css'>

<style type=\"text/css\">


.c
{	font-weight: bold;
	font-family:  monospace;
}
</style></head>

<body><center>";

ListNav(); 

echo "<p><h1>Search Commands</h1></center>
<p>
<div class=\"navanchs\"><a href=\"#planetlabels\">Planet Labels</a> |  <a href=\"#planetcheckboxesandratingfields\">Planet Checkboxes and Rating Fields</a><br><a href=\"#filesearch\">File Search Commands</a><br><a href=\"#otherattributes\">Other Attributes</a> | <a href=\"#attributecheckboxes\">Attribute Checkboxes</a> | <a href=\"#songlength\">Song Length</a><br><a href=\"#searchformoptions\">Search Form Options</a>: <a href=\"#displayoptions\">Display Options</a> | <a href=\"#outputoptions\">Output Options</a><br><a href=\"#multitablesearch\">Multitable Search Commands</a></div>
<p>

<div id='maintext'>
This page outlines the commands available for the Astrosorting Music Database's custom search engine.  These commands are in what I pretentiously call AMODB Query Language, or AMODBQL. :-)
<p>
Multiple commands can be entered, and they can be separated by semicolons (;) or just placed on separate lines in the search query text box.  Most commands can accept multiple arguments and negative arguments.  Multiple arguments are usually separated by commas.  Negative arguments are preceded by \"!\".
<p>
<br>
Optionally, instead of using the custom search engine, you can run you own custom SQL query in case you want to do a search that isn't possible via these search commands.  All such queries have \"SELECT\" automatically added to the beginning of them, just to make it less easy to type in some kind of database-destroying SQL command.
<p>
So, if you paste in a SELECT query and it doesn't work, it might be because you need to take \"SELECT\" out of what you pasted so the query that is sent to the database doesn't begin with \"SELECT SELECT\".
<p>
If you enter a custom SQL query, any AMODBQL commands will be ignored.

<p>
<br>
By the way, if you're at an http:// address, it's impossible to open local links on your hard drive using the file:// protocol, so, if you go to (for instance) <a href=\"http://localhost/amodb/output/private/Astrosort.html\">http://localhost/amodb/output/private/Astrosort.html</a> after you output an astrosorted music list, you'll find the song links won't do anything.
<p>
This is a security feature built into your web browser.  I don't recommend turning it off - instead, just make some bookmarks which go to those files using the file:// protocol instead of http:// , and the local links should hopefully work fine. (Though you might have to mess around with some other settings - can't remember what, though).
<p>
<center><table><tr><td><pre><li>file://localhost/C:/xampp/htdocs/amodb/output/private/Astrosort.html
<li>file://localhost/C:/xampp/htdocs/amodb/output/private/Search.html
<li>file://localhost/C:/xampp/htdocs/amodb/output/private/mercury.shtml
<li>file://localhost/C:/xampp/htdocs/amodb/output/private/Output.m3u</pre></table></center>
<p>
<br>
This commands list page is actually dynamically generated, so, if you change any of the lists of commands in lib-search.php, they will be reflected in this page automatically.

<p>
<br>
<a name=\"planetlabels\"></a>
<hr width=75%><p><br>

<center><h2>Planet Labels</h2></center>
<p>";

PrintCommandsArray($label1commands); br();
PrintCommandsArray($label2commands); br();
PrintCommandsArray($label3commands); p();

echo "The basic label search commands.  Searches for songs where whatever label you specified is whatever planet label you specified.
<p>
You can use abbreviated or non-abbreviated planet names, or even numbers.  The labels are numbered as follows:
<p>
<center><table cellpadding=5><tr><td>
1. Mercury<br>
2. Venus<br>
3. Mars
<td>
4. Jupiter<br>
5. Saturn<br>
6. Uranus
<td>
7. Neptune<br>
8. Pluto<br>
9. Eris</table></center>
<p>
Here are all the planet names you can use.  The capitalization doesn't matter.<p>";

PrintCommandsArray($allplanames);

echo "<p>
<ul>Syntax examples:<br>
<span class=\"c\">l1 mars, ju</span> - Finds songs where label 1 is either Mars or Jupiter.<br>
<span class=\"c\">l2 venus</span> - Finds songs where label 2 is Venus.<br>
<span class=\"c\">l3 !5, !8</span> - Finds songs where label 3 is not Saturn and not Pluto.</ul><p><br><hr width=25%><p><br>";

PrintCommandsArray($label1or2commands); 

echo " - Searches for songs where labels 1 and 2 are any of the arguments you entered.
<p>
<ul>Examples:<p><span class=\"c\">l12 me, ma, ur</span><p>
Finds songs where label 1 and 2 are both either Mercury, Mars, or Uranus.<p><br>

<span class=\"c\">l12 !ve</span><p>
Finds songs where label 1 and label 2 can't be Venus.
</ul><p><br>";

PrintCommandsArray($label2or3commands); 

echo " - Same thing for labels 2 and 3.<p><br><hr width=25%><p><br>";

PrintCommandsArray($eachlabelcommands); 

echo " - Searches for songs where labels 1, 2 and 3 contain any of the arguments you gave.
<p>
<ul>Examples:<p><span class=\"c\">la ve, sa, ne</span><br>
Searches for all combinations of Venus/Saturn/Neptune in any of the three main labels.
<p>
<br>
<span class=\"c\">la !sa, !pl</span><br>
Finds songs with no Saturn main labels and no Pluto main labels.

</ul><p><br><hr width=25%><p><br>";

PrintCommandsArray($eachlabelandsublabelcommands);

echo " - The same thing, but additionally searches sublabels.  The search might be a bit slower since I didn't go out of my way to make the sublabels stuff \"<a href=\"http://en.wikipedia.org/wiki/Database_normalization\" class=ext>normalized</a>\", as it's called in database programming jargon.
<p>

The sublabels field isn't even limited to containing just planet names - it can contain any text.  But, the sublabel text in the database has to contain non-abbreviated planet names in order for this search to work correctly.
<p>
The arguments you enter with these commands can be abbreviated - the search engine takes your input, translates it into non-abbreviated planet names, then conducts a search of the sublabels field of all songs to find the results.

<p>
Yes, there's probably a better way to do it, but I just don't want to, yet.  This has been such a lot of work already I don't want to get _too_ nitpicky.  It will probably be possible to someday create a way to do an automated conversion to a better system, so I'm just going to keep on doing it the way I'm doing it for now, since it's not like I'm getting myself more and more irreversibly entrenched in a less than ideal system by continuing to do it this way.
<p>
If I had realized I was going to start using the sublabels so habitually, I might have done things differently to start with.

<p><br><hr width=25%><p><br>";

PrintCommandsArray($sublabelcommands);

echo " - Finds only songs which have all of the sublabels you gave, not just one or the other.<p>";

PrintCommandsArray($sublabelorcommands);

echo " - Finds songs with any of the sublabels you gave (like Venus or Neptune, or both).<p>";

PrintCommandsArray($sublabelxcommands);

echo " - Probably less useful than the other two.  Finds an exact match to the string you put in, so you can find all songs with the sublabel \"(Venus/Jupiter)\" or whatever else.<p><br>

<a name=\"planetcheckboxesandratingfields\"></a>
<hr width=25%><p><br>

<center><h3>Planet Checkboxes and Rating Fields</h3></center>
<p>
In my experience, these aren't really quite as useful as doing searches based on the three main labels, or the sublabels field, but that may be because I use the three main label and sublabel fields more consistently than I fill out the rating fields - even though I usually do check at least a few of the checkboxes most of the time.  However, I don't really have the patience to sit there and think up 9 different ratings from 0-4 for every label for each song.<p><br>";

PrintCommandsArray($allplanames);

echo "<p><ul><li><i><b>0 arguments</b></i> - Finds songs with that planet's checkbox checked.
<p>
Examples: <span class=\"c\">ve; pl</span>
<p>
<li><b><i>0 arguments, with the command preceded by an exclamation point</b></i> - Finds songs which, in that planet's rating field, either have an X (signifying a song which definitely isn't described by that label) or 0 (no rating filled in, but not a null value - songs with null values in the rating field won't even turn up in the search).
<p>
Examples: <span class=\"c\">!pl; !ju</span>
<p>
<li><i><b>1 argument, either a number from 0 to 4, or X</b></i> - Find songs with that planet's checkbox checked and the rating equal to that number (or X).
<p>
Examples: <span class=\"c\">ma 3; ur 2</span>
<p>
<li><b><i>2 arguments, a comparison operator like ";

PrintCommandsArray($possiblecomparisons);

echo " and a number from 0 to 4</b></i> - Finds songs where that planet's rating is less than, greater than, equal to, etc. the number you input.
<p>
Example: <span class=\"c\">ne >= 2</span> - Songs where Neptune's rating is greater than or equal to 2.</ul>
<p>
<br>
<a name=\"filesearch\"></a>
<hr width=75%><p><br>";

echo "<center><h2>File Search Commands</h2></center><p>";

PrintCommandsArray($filenamecommands);

echo " - Finds songs where the filename contains strings like each of the arguments you entered.  All of the strings have to be present.
<p>
<ul>Example:<br>
<span class=\"c\">f castle, dark</span>
<p>
Finds all songs which have *castle* and *dark* somewhere in the file name.</ul><p><br>";

PrintCommandsArray($filenameorcommands);

echo " - Finds songs where the filename contains strings like any of the arguments you entered.
<p>
<ul>Example:<br>
<span class=\"c\">fo castle, dark</span>
<p>

Finds all songs which have *castle* or *dark* somewhere in the file name.</ul><p><br>";

PrintCommandsArray($filenamexcommands );


echo " - Finds songs with the exact file name you entered.  Capitalization doesn't matter, but you must include the file extension (like .mp3) at the end of the file name.<p><br><hr width=25%><p><br>";


PrintCommandsArray($extcommands);

echo " - Finds songs with the file extension you entered, like MP3 or MID.  Capitalization doesn't matter.<p><br><hr width=25%><p><br>";


PrintCommandsArray($localfoldercommands);

echo " - Finds songs in any of the folders you entered.  Spaces don't matter, capitalization doesn't matter.  Can take multiple arguments, like most of the rest of the commands, but actually can't take negative arguments, currently.<p><br>

<a name=\"otherattributes\"></a>
<hr width=75%><p><br>


<center><h2>Searches for Other Attributes</h2></center>
<p>
";
PrintCommandsArray($titlecommands);

echo " - Finds songs which have titles containing each of the words you entered.<p><br>";

PrintCommandsArray($titleorcommands);

echo " - Finds songs which have titles containing any of the words you entered.<p><br>";

PrintCommandsArray($titlexcommands);

echo " - Finds songs which have the exact title you entered.<p><br><hr width=25%><p><br>";

PrintCommandsArray($urltypecommands);

echo " - Finds songs which have any of the URL types you entered.<p><br><hr width=25%><p><br>";

PrintCommandsArray($genrecommands);

echo " - Finds songs which have genres containing any of the strings you entered.<p><br><hr width=25%><p><br>";

PrintCommandsArray($nullcommands);

echo " - Finds songs whose titles are null values in the database - a good indication of a song which was imported using the Import Folder function and hasn't been edited yet.

<p><br>
<a name=\"attributecheckboxes\"></a>
<hr width=25%><p><br>

<center><h3>Attribute Checkboxes</h3></center>
<p>";

PrintCommandsArray($hascommands); br();
PrintCommandsArray($hasntcommands);

echo "<p>Finds songs which have or don't have the attributes of your choice from the list below.
<p>
<br>
Possible attributes:<p>";
PrintCommandsArray($attributes);

echo "<p><br>

<a name=\"songlength\"></a>
<hr width=25%><p><br>

<center><h3>Song Length</h3></center>
<p>";
PrintCommandsArray($minequalscommands); br();
PrintCommandsArray($secequalscommands); br();
PrintCommandsArray($hourequalscommands );

echo "<p>Finds songs where the minutes, seconds, or hours equal any of the numbers you input.<p><br>";

PrintCommandsArray($minlesscommands ); br();
PrintCommandsArray($seclesscommands ); br();
PrintCommandsArray($hourlesscommands );

echo "<p>Finds songs where the minutes, seconds, or hours are less than the number you input. Make sure you have a space in between the command and the argument.<p><br>";

PrintCommandsArray($minmorecommands ); br();
PrintCommandsArray($secmorecommands ); br();
PrintCommandsArray($hourmorecommands );

echo "<p>Finds songs where the minutes, seconds, or hours are greater than the number you input. Make sure you have a space in between the command and the argument.<p><br>

<a name=\"searchformoptions\"></a>
<hr width=75%><p><br>
<center><h2>Search Form Options</h2>
<p>
These make it so you don't have to mess with the checkboxes on the search form page.

<p><br>
<a name=\"displayoptions\"></a>
<h3>Display Options</h3></center><p>";

PrintCommandsArray($displaylinkscommands);

echo " - <b>Display Folder/Song Links</b> - Displays direct links to the folders/songs.<p>";

PrintCommandsArray($displayeditlinkscommands);

echo " - <b>Display Edit Links</b> - Displays links to the songs' edit pages.
<p>
<br>
<a name=\"outputoptions\"></a>
<hr width=25%><p><br>

<center><h3>Output Options</h3></center>
<p>
If you want to change the location of the files where things are output to, or their file names, edit the source code of searchandplaylistgen.php.<p><br>";

PrintCommandsArray($outputplaylistcommands ); 

echo " - <b>Output Playlist to File</b> - Outputs a Winamp playlist of the search results to a file on your hard drive.<p>";

PrintCommandsArray($outputsearchcommands);

echo " - <b>Output Search Results File</b> - Outputs the search results into a file on your hard drive, featuring local links to the songs as well as the folders they're in.<p>";

PrintCommandsArray($outputeditlinkscommands); 

echo " - <b>Output Search Results File With Edit Links</b> - Same thing, except with edit links and not with local links to the songs/folders.
<p>
<br>
<hr width=75%><p><br>

<a name=\"multitablesearch\"></a>
<center><h2>Multitable Search Commands</h2></center>
<p>

These require multiple tables to be looked at, so I'm guessing they may take marginally longer than other types of searches.
<p>";

PrintCommandsArray($sourcecommands);
br();
PrintCommandsArray($performercommands); 
br();
PrintCommandsArray($vocalistcommands);
br();
PrintCommandsArray($remixercommands);
br();
PrintCommandsArray($composercommands);
p();

echo "Finds songs whose exact source name, performer name, vocalist name, remixer name, composer name, or abbreviation of any of the foregoing, is the same as any of the arguments you input.<p><br>";

PrintCommandsArray($anyrolecommands); p();

echo "The same thing but scans for that exact name or abbreviation in any role, instead of just one role.";

p(); br();

PrintCommandsArray($sourcelikecommands); br();
PrintCommandsArray($performerlikecommands); br();
PrintCommandsArray($vocalistlikecommands); br();
PrintCommandsArray($remixerlikecommands); br();
PrintCommandsArray($composerlikecommands); p();

echo "Finds songs whose source name, performer name, vocalist name, remixer name, composer name, or abbreviation of any of the foregoing, is like any of the strings you input.<p><br>";

PrintCommandsArray($anyrolelikecommands); p();

echo "The same thing but scans for any role for names or abbreviations like any of the strings you input.<p><br><hr width=75%><p><br><center>";

ListNav(); 

?>